#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

module Inertia

class Point < Object

  attr :x, true
  attr :y, true

  def initialize( x = 0, y = 0 )
    @x, @y = x, y
  end

end

class Point < Object

  attr :x, true
  attr :y, true

  @@ZERO = Point.new
  
  def Point.ZERO()
    return @@ZERO
  end

  def initialize( x = 0, y = 0 )
    @x, @y = x, y
  end

  def to_point()
    return self
  end

  def inspect()
    return "[#{x}, #{y}]"
  end
  
  def +( value ) Point.new( @x + value.x, @y + value.y ) end
  def -( value ) Point.new( @x - value.x, @y - value.y ) end
  def *( value ) Point.new( @x * value, @y * value ) end
  def /( value ) Point.new( @x / value, @y / value )  end

end

end


class Array

  def to_point()
    return Inertia::Point.new( self[0], self[1] )
  end

end
