#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

module Inertia

  class Graphics < Object
  
    attr :line_width

    def initialize()
      self.line_width = 1.0
    end
    
    def line_width=( width )
      @line_width = width
      @half_width = @line_width / 2.0
      GL::LineWidth( width )
    end

    def translate( x, y, z = 0 )
      GL::Translate( x, y, z )
    end
    
    def solid_rect( origin, extent, colors )
      GL::Begin( GL::QUADS )
        GL::Color( colors[0] )
          GL::Vertex( origin.x + extent.x,            origin.y )
          GL::Vertex(            origin.x,            origin.y )
        GL::Color( colors[1] ) if colors.size == 2
          GL::Vertex(            origin.x,            extent.y )
          GL::Vertex( origin.x + extent.x, origin.y + extent.y )
      GL::End()
    end
    
    def line_rect( origin, extent, color )
      GL::Color( color ); 

      GL::Begin( GL::LINE_LOOP )
        GL::Vertex(            origin.x - @half_width,            origin.y - @half_width )
        GL::Vertex(            origin.x - @half_width, origin.y + extent.y + @half_width )
        GL::Vertex( origin.x + extent.x + @half_width, origin.y + extent.y + @half_width )
        GL::Vertex( origin.x + extent.x + @half_width,            origin.y - @half_width )
      GL::End()
    end
    
    def line_loop( points )
    end
  
  end

end
