#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

class Ball < Inertia::View

  @source = __FILE__

  def initialize()
    super
    self.extent = [50, 50]
    @back_color = [1.0, 0.0, 0.0]
    @direction = Inertia::Point.new( 1, 1 )
  end

  def draw_content()
    super

    return if parent == nil or parent == $screen
    @origin += @direction

    if parent and left < 0
      @direction.x = -@direction.x
      self.left = 0
    end
    if parent and left + width > parent.width
      @direction.x = -@direction.x
      self.left = parent.width - width
    end
    if parent and top < 0
      @direction.y = -@direction.y
      self.top = 0
    end
    if parent and top + height > parent.height
      @direction.y = -@direction.y
      self.top = parent.height - height
    end
  end
  
end

