#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

require 'view'

module Inertia

class Button < View

  @source = __FILE__
  @fields = [:caption, :action]

  attr :caption, true
  attr :text_color, true
  attr :bkg_color, true
  attr :action, true
  attr :mouse_down
  
  def mouse_down?
    @mouse_down
  end

  # -------------------------------------------------------------------------- #

  def initialize()
    super
    @text_color = [0.1, 0.1, 0.1]
    @bkg_color = [0.8, 0.9, 1.0]
    @color_1 = [1.0, 1.0, 1.0]
    @color_2 = [0.9, 0.9, 0.9]
    self.extent = [100, 25]
    self.caption = "Click Me!"
  end

  def caption=( caption )
    @caption = caption
    self.width = [100, $systemFont.text_length( caption ) + 30].max()
  end
  
  # -------------------------------------------------------------------------- #

  def mouse_down( button, origin )
    @mouse_down = true
  end

  def mouse_up( button, origin )
    action.call() if action
    @mouse_down = false
  end

  # -------------------------------------------------------------------------- #
  class Drawing; end
  # -------------------------------------------------------------------------- #

  def draw_content()
  end

  def draw_border()
  end

end # Button

# ---------------------------------------------------------------------------- #
# ---------------------------------------------------------------------------- #

class HoverButton < Button

  def draw_border()
    super if mouse_hover?
  end

end # HoverButton

end
