#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

require 'view'

module Inertia

class Clock < View

  @source = __FILE__
  
  def draw_content()
    time = Time.now
    hour = (time.hour * 3600 + time.min * 60 + time.sec) * (2 * Math::PI / (12 * 60 * 60))
    minute = (time.min * 60 + time.sec) * (2 * Math::PI / (60 * 60))
    second =  (time.sec) * (2 * Math::PI / 60)
    size = [width, height].min()

    GL::Color( 1.0, 1.0, 1.0 )
    GL::Begin( GL::QUADS )
      GL::Vertex( 0, 0 )
      GL::Vertex( 0, height )
      GL::Vertex( width, height )
      GL::Vertex( width, 0 )
    GL::End()
    
    GL::Translate( width / 2, height / 2, 0 )
    GL::Rotate( -90, 0, 0, 1 )
    GL::Translate( 0.5, 0.5, 0 )

    GL::LineWidth( 3.0 )
    GL::Color( 0.1, 0.1, 0.1 )
    GL::Begin( GL::LINES )
      GL::Vertex( -Math.cos( hour ) * (size / 10), -Math.sin( hour ) * (size / 10) )
      GL::Vertex( Math.cos( hour ) * (size / 3), Math.sin( hour ) * (size / 3) )
    GL::End()

    GL::LineWidth( 2.0 )
    GL::Begin( GL::LINES )
      GL::Vertex( -Math.cos( minute ) * (size / 10), -Math.sin( minute ) * (size / 10) )
      GL::Vertex( Math.cos( minute ) * (size / 2 - 2), Math.sin( minute ) * (size / 2 - 2) )
    GL::End()

    GL::LineWidth( 1.0 )
    GL::Color( 0.75, 0.75, 0.75 )
    GL::Begin( GL::LINES )
      GL::Vertex( -Math.cos( second ) * (size / 10), -Math.sin( second ) * (size / 10) )
      GL::Vertex( Math.cos( second ) * (size / 2 - 2), Math.sin( second ) * (size / 2 - 2) )
    GL::End()
  end
  
end

end
