#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

require 'view'

module Inertia

class Label < View

  @source = __FILE__

  attr :text, true
  attr :text_color, true

  # - Button initialization -------------------------------------------------- #

  def initialize()
    super
    self.extent = [100, 25]
    self.text = "Label"
    @text_color = [0.1, 0.1, 0.1]
  end

  # - Button drawing --------------------------------------------------------- #

  def draw_content()
    GL::Color( text_color ); 
    GL::Translate( 0.0, height / 2 - $systemFont.font.height / 2, 0.0 )
    $systemFont.draw_string( text )
  end

  def draw_border()
  end

  # - Button miscellanious --------------------------------------------------- #

  #def contains_point( point )
  #  false
  #end

end # Label

class DropSource < View

  @source = __FILE__

  attr :bkg_color
  attr :drop_target

  def initialize()
    super
    @bkg_color = [rand, rand, rand]
  end

  def mouse_drag( origin )
    $screen.drag_object( @bkg_color )
  end

  def drag_accept( origin, object )
    @drop_target = true
  end

  def drag_drop( object )
    print "drag_drop = ", object, "\n"
    @bkg_color = object
  end

  def draw_content()
      GL::Begin( GL::QUADS )
        GL::Color( bkg_color )
          GL::Vertex(     0,      0 )
          GL::Vertex(     0, height )
          GL::Vertex( width, height )
          GL::Vertex( width,      0 )
      GL::End()
  end

end # DropSource

end
