#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

module Inertia

class Shelf < View

  alias :view_add_child :add_child
  alias :view_remove_child :remove_child

  def initialize()
    super
    self.extent = [500, 500]
    @position = 0
    @buttons = {}
  end
  
  def add_child( child )
    super
    if child.instance_of? Window
      view_add_child( button = Button.new )
      button.origin = [@position, height - 25]
      button.action = Action.new( self, :activate_view, [child] )
      @buttons[child] = button
      @position += 101
    end
  end

  def remove_child( child )
    super
    if @buttons[child]
      view_remove_child( @buttons[child] )
      @buttons.delete( child )
      @position = 0
      @buttons.each do | key, button |
        button.origin = [@position, height - 25]
        @position += 101
      end
    end
  end
  
  def activate_view( view )
    view_remove_child( view )
    view_add_child( view )
  end
  
end

end
