#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

require 'view'
require 'widgets/editor'
require 'widgets/button'

module Inertia

class ClassEditor < Window

  @source = __FILE__

  def initialize()
    super
    file_editor = self
    self.title = "Class File Editor"
    self.extent = [450, 500]

    add_child( Label.new.with do
      self.origin = [10, 10]
      self.text = "Filename"
    end )

    add_child( @input = Input.new.with do
      self.origin = [70, 10]; self.extent = [200, 25]
    end )

    add_child( Button.new.with do
      self.caption = "Accept"
      self.origin = [340, 10]
      self.reshape = [:move, nil]
      self.action = Action.new( file_editor, :accept_changes, [] )
    end )
    
    add_child( @editor = Editor.new.with do
      self.origin = [0, 45]; self.extent = [450, 500 - 96]
      self.reshape = [:size, :size]
    end )

    add_child( @status = Label.new.with do
      self.origin = [10, 500 - 50]
      self.text = "0, 0"
      self.reshape = [nil, :move]
    end )
  end

  def open_file( filename )
    @editor.load_from_file( filename )
    @input.text = filename
  end

  def accept_changes()
    Object.module_eval( @editor.lines.join( "\n") )
  end
  
end

end
