#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

module Inertia

class Inspector < Window

  @source = __FILE__

  attr :object
  attr :sticky

  def initialize()
    super
    self.title = "Object Inspector"

    add_child( Label.new.with do
      self.origin = [10, 10]
      self.text = "Object:"
    end )

    add_child( @object_label = Label.new.with do
      self.origin = [60, 10]
    end )

    add_child( @table = Table.new.with do
      self.model = ObjectModel.new
      self.model.object = $screen
      self.origin = [0, 40]; self.extent = [300, 200 - 65]
      self.reshape = [:size, :size]
    end )
  end
  
  def object=( object )
    @table.model.object = object
    @object_label.text = "#<%s:0x%x>" % [object.class, object.object_id]
  end
  
end # Inspector

end
