#
# Copyright (c) 2006 Mike L. Austin.  All rights reserved.
# see LICENCE.txt for details
#

class Action
  attr :target
  attr :message
  attr :args

  def initialize( target, message, args )
    @target, @message, @args = target, message, args
  end
end

class Button
  attr :action, true
  attr :caption, true

  def mouse_click()
    action.target.send( action.message, *action.args )
  end
end

class TicTacToe

  def initialize()
    @turn = :x
    @squares = Array.new( 9 )
  end

  def select_square( button, square )
    button.caption = @turn

    puts 'select_square()'
    @squares[square] = @turn
    return @turn if check_winner()
    #@turn = if @turn == :x then :o else :x end
    return nil
  end

  def check_winner()
    # Check horizontal
    case [@turn, @turn, @turn]
         # Check horizontal
    when [@squares[0], @squares[1], @squares[2]],
         [@squares[3], @squares[4], @squares[5]],
         [@squares[6], @squares[7], @squares[8]],
         # Check vertical
         [@squares[0], @squares[3], @squares[6]],
         [@squares[1], @squares[4], @squares[7]],
         [@squares[2], @squares[5], @squares[8]],
         # Check diagonal
         [@squares[0], @squares[4], @squares[8]],
         [@squares[2], @squares[4], @squares[6]]
      show_winner()
    end
  end

  def show_winner()
    puts "Winner is #{@turn}"
  end

end

tto = TicTacToe.new

b0 = Button.new;  b0.action = Action.new( tto, :select_square, [b0, 0] )
b1 = Button.new;  b1.action = Action.new( tto, :select_square, [b1, 1] )
b2 = Button.new;  b2.action = Action.new( tto, :select_square, [b2, 2] )

b0.mouse_click()
b1.mouse_click()
b2.mouse_click()

